"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.promise.js");

require("core-js/modules/es.json.stringify.js");

var _react = _interopRequireWildcard(require("react"));

var _icons = require("@ant-design/icons");

var _antd = require("antd");

var _formik = require("formik");

var Yup = _interopRequireWildcard(require("yup"));

require("antd/dist/antd.css");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactRouterDom = require("react-router-dom");

var _constant = require("../constant");

var _SignupFormModule = _interopRequireDefault(require("./SignupForm.module.scss"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const SignupForm = _ref => {
  var _isAuthenticate$messa;

  let {
    background,
    textColor,
    label,
    storeToken,
    realm,
    clientId,
    authhandlerUrl,
    backendUrl
  } = _ref;
  const INITIAL_DATA_API = "".concat(backendUrl, "/staff/initial-data");

  const initialDataHeaders = _objectSpread(_objectSpread({}, _constant.signinApiHeaders), {}, {
    organizationName: "hcinbox"
  });

  const signUpLabel = "Sign Up";
  const navigate = (0, _reactRouterDom.useNavigate)();
  const {
    invitationId
  } = (0, _reactRouterDom.useParams)();
  const SIGNUP_API = !invitationId ? "".concat(authhandlerUrl, "/staff") : "".concat(backendUrl, "/staff/signup-with-invitation");
  const {
    values,
    touched,
    errors,
    handleChange,
    handleBlur,
    handleSubmit
  } = (0, _formik.useFormik)({
    initialValues: {
      firstName: "",
      lastName: "",
      email: "",
      password: ""
    },
    validationSchema: Yup.object().shape({
      firstName: Yup.string().matches(/^(?:[\t-\r \x2D0-9A-Za-z\xA0\xB5\xC0-\xD6\xD8-\xF6\xF8-\u01BA\u01BC-\u01BF\u01C4\u01C6\u01C7\u01C9\u01CA\u01CC-\u01F1\u01F3-\u0293\u0295-\u02AF\u0370-\u0373\u0376\u0377\u037B-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0560-\u0588\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FD-\u10FF\u13A0-\u13F5\u13F8-\u13FD\u1680\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1D00-\u1D2B\u1D6B-\u1D77\u1D79-\u1D9A\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1F87\u1F90-\u1F97\u1FA0-\u1FA7\u1FB0-\u1FB4\u1FB6-\u1FBB\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCB\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFB\u2000-\u200A\u2028\u2029\u202F\u205F\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2134\u2139\u213C-\u213F\u2145-\u2149\u214E\u2183\u2184\u2C00-\u2C7B\u2C7E-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u3000\uA640-\uA66D\uA680-\uA69B\uA722-\uA76F\uA771-\uA787\uA78B-\uA78E\uA790-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F5\uA7F6\uA7FA\uAB30-\uAB5A\uAB60-\uAB68\uAB70-\uABBF\uFB00-\uFB06\uFB13-\uFB17\uFEFF\uFF21-\uFF3A\uFF41-\uFF5A]|\uD801[\uDC00-\uDC4F\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC]|\uD803[\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD806[\uDCA0-\uDCDF]|\uD81B[\uDE40-\uDE7F]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB]|\uD837[\uDF00-\uDF09\uDF0B-\uDF1E]|\uD83A[\uDD00-\uDD43])*$/, "Invalid First Name").required("First name required"),
      lastName: Yup.string().matches(/^(?:[\t-\r \x2D0-9A-Za-z\xA0\xB5\xC0-\xD6\xD8-\xF6\xF8-\u01BA\u01BC-\u01BF\u01C4\u01C6\u01C7\u01C9\u01CA\u01CC-\u01F1\u01F3-\u0293\u0295-\u02AF\u0370-\u0373\u0376\u0377\u037B-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0560-\u0588\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FD-\u10FF\u13A0-\u13F5\u13F8-\u13FD\u1680\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1D00-\u1D2B\u1D6B-\u1D77\u1D79-\u1D9A\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1F87\u1F90-\u1F97\u1FA0-\u1FA7\u1FB0-\u1FB4\u1FB6-\u1FBB\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCB\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFB\u2000-\u200A\u2028\u2029\u202F\u205F\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2134\u2139\u213C-\u213F\u2145-\u2149\u214E\u2183\u2184\u2C00-\u2C7B\u2C7E-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u3000\uA640-\uA66D\uA680-\uA69B\uA722-\uA76F\uA771-\uA787\uA78B-\uA78E\uA790-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F5\uA7F6\uA7FA\uAB30-\uAB5A\uAB60-\uAB68\uAB70-\uABBF\uFB00-\uFB06\uFB13-\uFB17\uFEFF\uFF21-\uFF3A\uFF41-\uFF5A]|\uD801[\uDC00-\uDC4F\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC]|\uD803[\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD806[\uDCA0-\uDCDF]|\uD81B[\uDE40-\uDE7F]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB]|\uD837[\uDF00-\uDF09\uDF0B-\uDF1E]|\uD83A[\uDD00-\uDD43])*$/, "Invalid Last Name"),
      email: Yup.string().email("Invalid email address format").required("Email required"),
      password: Yup.string().matches(/^(?=.*[A-Za-z])(?=.*[@$!%*#?&])[A-Za-z0-9@$!%*#?&]{6,}$/, "Password should be atleast 6 characters long and should contain a special symbol!").required("Password required")
    }),
    onSubmit: async values => {
      submitSignupForm(values);
    }
  });
  const [isAuthenticate, setAuthenticationStatus] = (0, _react.useState)({
    status: false,
    message: ""
  });
  const [loading, setLoading] = (0, _react.useState)(false);

  const submitSignupForm = async formValues => {
    const {
      firstName,
      lastName,
      email,
      password
    } = formValues;
    let res = null;
    let userDetails = null;
    let body = null;
    let tokenSet = null;

    try {
      setLoading(true);

      if (invitationId) {
        body = _objectSpread(_objectSpread({}, formValues), {}, {
          invitationId
        });
      } else {
        body = _objectSpread({}, formValues);
      }

      res = await fetch(SIGNUP_API, {
        method: "POST",
        headers: _constant.signinApiHeaders,
        body: JSON.stringify(body)
      });

      if (!res.ok) {
        throw new Error(res);
      }

      tokenSet = await res.json();

      if (tokenSet.error) {
        throw new Error(tokenSet);
      }

      storeToken(tokenSet);
      initialDataHeaders.Authorization = "Bearer ".concat(tokenSet.access_token);
      userDetails = await fetch(INITIAL_DATA_API, {
        headers: initialDataHeaders
      });

      if (!userDetails.ok) {
        throw new Error(userDetails);
      }

      userDetails = await userDetails.json();

      if (!userDetails.success) {
        throw new Error("Server Error!");
      }

      localStorage.setItem('userDetails', JSON.stringify(userDetails.data));
      setAuthenticationStatus(_objectSpread(_objectSpread({}, isAuthenticate), {}, {
        status: true,
        message: ""
      }));
      setLoading(false);
      navigate("/chat");
    } catch (error) {
      sessionStorage.removeItem("access_token");
      sessionStorage.removeItem("refresh_token");
      let msg;
      setLoading(false);

      if (userDetails !== null) {
        msg = await userDetails.json();
        setAuthenticationStatus(_objectSpread(_objectSpread({}, isAuthenticate), {}, {
          status: false,
          message: msg.error
        }));
      } else {
        if (tokenSet === null) {
          msg = await res.json();
        }

        setAuthenticationStatus(_objectSpread(_objectSpread({}, isAuthenticate), {}, {
          status: false,
          message: !msg ? tokenSet.error : msg.message
        }));
      }
    }
  };

  const handleValidationStatus = key => {
    return !touched[key] && !errors[key] ? "" : touched[key] && !errors[key] ? "success" : touched[key] && errors[key] ? "error" : "";
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    className: _SignupFormModule.default.SignupForm
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: _SignupFormModule.default.SignupForm__signUpContainer
  }, /*#__PURE__*/_react.default.createElement("h3", null, "Great to have you here"), /*#__PURE__*/_react.default.createElement("form", {
    onSubmit: handleSubmit
  }, /*#__PURE__*/_react.default.createElement(_antd.Row, {
    className: _SignupFormModule.default.SignupForm__signUpContainer__name,
    gutter: [16]
  }, /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 12
  }, /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    className: _SignupFormModule.default.SignupForm__signUpContainer__formItem,
    label: "First Name",
    name: "firstName",
    validateStatus: handleValidationStatus("firstName"),
    hasFeedback: true
  }, /*#__PURE__*/_react.default.createElement(_antd.Input, {
    id: "firstName",
    name: "firstName",
    type: "text",
    onChange: handleChange,
    onBlur: handleBlur,
    value: values.firstName,
    placeholder: "input first name"
  }), touched.firstName && errors.firstName ? /*#__PURE__*/_react.default.createElement("div", {
    role: "alert",
    className: _SignupFormModule.default.SignupForm__signUpContainer__formItem__error
  }, errors.firstName) : null)), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 12
  }, /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    className: _SignupFormModule.default.SignupForm__signUpContainer__formItem,
    label: "Last Name",
    name: "lastName",
    hasFeedback: true,
    validateStatus: handleValidationStatus("lastName")
  }, /*#__PURE__*/_react.default.createElement(_antd.Input, {
    id: "lastName",
    name: "lastName",
    type: "text",
    onChange: handleChange,
    onBlur: handleBlur,
    value: values.lastName,
    placeholder: "input last name"
  }), touched.lastName && errors.lastName ? /*#__PURE__*/_react.default.createElement("div", {
    role: "alert",
    className: _SignupFormModule.default.SignupForm__signUpContainer__formItem__error
  }, errors.lastName) : null))), /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    className: _SignupFormModule.default.SignupForm__signUpContainer__formItem,
    label: "Email",
    name: "email",
    validateStatus: handleValidationStatus("email"),
    hasFeedback: true
  }, /*#__PURE__*/_react.default.createElement(_antd.Input, {
    id: "email",
    name: "email",
    type: "text",
    onChange: handleChange,
    onBlur: handleBlur,
    value: values.email,
    placeholder: "example@gmail.com"
  }), touched.email && errors.email ? /*#__PURE__*/_react.default.createElement("div", {
    role: "alert",
    className: _SignupFormModule.default.SignupForm__signUpContainer__formItem__error
  }, errors.email) : null), /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    className: _SignupFormModule.default.SignupForm__signUpContainer__formItem,
    label: "Password",
    name: "password",
    validateStatus: handleValidationStatus("password"),
    hasFeedback: true
  }, /*#__PURE__*/_react.default.createElement(_antd.Input.Password, {
    id: "password",
    name: "password",
    type: "text",
    onChange: handleChange,
    onBlur: handleBlur,
    value: values.password,
    placeholder: "Password"
  }), touched.password && errors.password ? /*#__PURE__*/_react.default.createElement("div", {
    role: "alert",
    className: _SignupFormModule.default.SignupForm__signUpContainer__formItem__error
  }, errors.password) : null), /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    className: _SignupFormModule.default.SignupForm__signUpContainer__formItem
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: _SignupFormModule.default.SignupForm__signUpContainer__formItem__signUpBtnContainer
  }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
    "data-testid": "sign-up-btn",
    style: {
      background: background,
      color: textColor
    },
    loading: loading,
    htmlType: "submit",
    icon: /*#__PURE__*/_react.default.createElement(_icons.LoginOutlined, null)
  }, invitationId ? label : signUpLabel))), /*#__PURE__*/_react.default.createElement("div", {
    className: _SignupFormModule.default.SignupForm__signUpContainer__helpMsg
  }, "Already have an account? ", /*#__PURE__*/_react.default.createElement("a", {
    onClick: () => navigate("/login")
  }, "Signin here")), (_isAuthenticate$messa = isAuthenticate.message) !== null && _isAuthenticate$messa !== void 0 && _isAuthenticate$messa.length ? /*#__PURE__*/_react.default.createElement("div", {
    className: _SignupFormModule.default.alert
  }, /*#__PURE__*/_react.default.createElement(_antd.Alert, {
    message: "Error",
    description: isAuthenticate.message,
    className: _SignupFormModule.default.SignupForm__signUpContainer__errorMsg,
    type: "error",
    showIcon: true
  })) : null), /*#__PURE__*/_react.default.createElement("footer", {
    className: _SignupFormModule.default.SignupForm__footer,
    "data-testid": "footer"
  }, "Need help? ", /*#__PURE__*/_react.default.createElement("span", null, "Feel free to"), "\xA0", /*#__PURE__*/_react.default.createElement("a", {
    href: "#"
  }, "Contact Us!"))));
};

SignupForm.propTypes = {
  background: _propTypes.default.string,
  textColor: _propTypes.default.string,
  label: _propTypes.default.string,
  size: _propTypes.default.string
};
SignupForm.defaultProps = {
  background: "rgba(9, 109, 217, 1)",
  textColor: "white",
  label: "Accept Invite",
  size: "medium"
};
var _default = SignupForm;
exports.default = _default;